#region Using directives

using System;
using System.Collections.Generic;
using System.Text;
using System.Threading;
using System.Workflow.Runtime;
using System.Workflow.Runtime.Hosting;

#endregion

namespace chapter3_sequential
{
    class Program
    {
        static void Main(string[] args)
        {
            using(WorkflowRuntime workflowRuntime = new WorkflowRuntime())
            {
                AutoResetEvent waitHandle = new AutoResetEvent(false);
                //
                workflowRuntime.WorkflowCreated += delegate(object sender, WorkflowEventArgs e)
                {
                    Console.WriteLine("Workflow created");
                };
                //ʼ
                workflowRuntime.WorkflowStarted += delegate(object sender, WorkflowEventArgs e)
                {
                    Console.WriteLine("Workflow started");
                };
                //
                workflowRuntime.WorkflowIdled += delegate(object sender, WorkflowEventArgs e)
                {
                    Console.WriteLine("Workflow idled");
                };
                //ͣ
                workflowRuntime.WorkflowSuspended += delegate(object sender, WorkflowSuspendedEventArgs e)
                {
                    Console.WriteLine("Workflow suspended");
                    //SuspendActivtyError
                    Console.WriteLine("\tReason: " + e.Error);
                    //ùִָ
                    e.WorkflowInstance.Resume();
                };
                //ָ
                workflowRuntime.WorkflowResumed += delegate(object sender, WorkflowEventArgs e)
                {
                    Console.WriteLine("Workflow resumed");
                    waitHandle.Set();
                };
                //
                workflowRuntime.WorkflowCompleted += delegate(object sender, WorkflowCompletedEventArgs e)
                {
                    Console.WriteLine("Workflow completed");
                    waitHandle.Set();
                };
                //ֹ
                workflowRuntime.WorkflowTerminated += delegate(object sender, WorkflowTerminatedEventArgs e)
                {
                    Console.WriteLine("Workflow terminated");
                    Console.WriteLine("\tException: " + e.Exception.Message);
                    waitHandle.Set();

                };

                WorkflowInstance instance = workflowRuntime.CreateWorkflow(typeof(chapter3_sequential.WorklowEvents));
                instance.Start();
                Console.Read();
                waitHandle.WaitOne();
            }
        }
    }
}
